#ifndef __COLORLAYOUT_H__
#define __COLORLAYOUT_H__

#include "DescriptorBase.h"

class __declspec (dllexport) ColorLayout : public DescriptorBase
{
public:
	//!constructor
	ColorLayout();

	friend std::ostream& operator << (std::ostream& os, ColorLayout& s);

	//! initialise the descriptor with the given parameters
	int Initialise(int sizeY,int sizeC);
	//!set size of the Y coefficients vector
	int SetSizeY(int sizeY);
	//!set size of the C (Cb-Cr) coefficients vector
	int SetSizeC(int sizeC);
	//!get number of the Y coefficients 
	int GetSizeY(void);
	//!get number of the C (Cb-Cr) coefficients 
	int GetSizeC(void);

	void PrintElements();
	size_t GetByteSize();
	std::string toString();

#ifdef USEXML
	XERCES_CPP_NAMESPACE::DOMElement *toXML(XERCES_CPP_NAMESPACE::DOMDocument* doc);
	void fillDescriptor(XERCES_CPP_NAMESPACE::DOMNodeList *ndList);

#endif

	//!match descriptors and return distance
	float match(ColorLayout *colLay);

	//!vector of Y coefficients
	std::vector<int> m_y_coeff;
	//!vector of Cb coefficients
	std::vector<int> m_cb_coeff;
	//!vector of Cr coefficients
	std::vector<int> m_cr_coeff;

};



#endif //__COLORLAYOUT_H__