#ifndef __COLORSTRUCTURE_H__
#define __COLORSTRUCTURE_H__

#include "DescriptorBase.h"

#define  NUM_COLOR_QUANT_SPACE  4
#define MAX_SUB_SPACE  5
#define BASE_QUANT_SPACE 256
#define BASE_QUANT_SPACE_INDEX 3

class __declspec (dllexport) ColorStructure : public DescriptorBase
{

public:
	//!constructor
	ColorStructure();

	friend std::ostream& operator << (std::ostream& os, ColorStructure& s);
	//!set current size of the descriptor vector
	int SetSize(int Size);
	//!get current size of the descriptor vector
	int GetSize();
	//!set target size of the descriptor
	int SetTargetSize(int TargetSize);
	//!get target size of the descriptor
	int GetTargetSize();
	//! initialise the descriptor with the given parameters
	int Initialise(int tSize);

	
	void PrintElements();
	size_t GetByteSize();
	std::string toString();
#ifdef USEXML
	XERCES_CPP_NAMESPACE::DOMElement *toXML(XERCES_CPP_NAMESPACE::DOMDocument* doc);
	void fillDescriptor(XERCES_CPP_NAMESPACE::DOMNodeList *ndList);
	
#endif

	//!match descriptors and return distance
	int match(ColorStructure *colStruc);

	//! descriptor vector
	std::vector<unsigned long> m_Data;

};



#endif //__COLORSTRUCTURE_H__