#ifndef __DESCRIPTORBASE_H__
#define __DESCRIPTORBASE_H__

#include <vector>
#include <sstream>
#ifdef USEXML
#include <xercesc/dom/DOM.hpp>
#endif


enum DescriptorType  { DC , CL , CST , SC , HT , EH , CS , RS };

class DescriptorBase
{
public:
	//! overidden oparator << for the descriptor vector
	friend  std::ostream& operator << (std::ostream& os, DescriptorBase& s);
	//! prints the descriptor vector
	virtual void PrintElements(void){};
#ifdef USEXML
	//! create descriptor's xml format and return a pointer to it
	virtual	XERCES_CPP_NAMESPACE::DOMElement *toXML(XERCES_CPP_NAMESPACE::DOMDocument* doc){return NULL;};

	//! copy descriptor data from xml file to descriptor object
	void fromXML(char* filename);

	//! copy descriptor data from xml node list to descriptor object
	virtual void fillDescriptor(XERCES_CPP_NAMESPACE::DOMNodeList *ndList){};

#endif

	//! convert descriptor data to string
	std::string toString();
	//!return size in bytes of descriptor in memory 
	size_t GetByteSize();

	//! declares the descriptor
	DescriptorType type;	
};

//! vector of DescriptorTypes
typedef std::vector<DescriptorType> DescriptorTypeVector;


#endif 