#ifndef __EDGEHISTOGRAM_H__
#define __EDGEHISTOGRAM_H__

#include "DescriptorBase.h"

class __declspec (dllexport) EdgeHistogram  : public DescriptorBase
{
public:
	//!constructor
	EdgeHistogram();

	friend std::ostream& operator << (std::ostream& os, EdgeHistogram& s);

	//!set size of the edge histogram vector
	void SetSize();

	void PrintElements();
	std::string toString();
#ifdef USEXML
	XERCES_CPP_NAMESPACE::DOMElement *toXML(XERCES_CPP_NAMESPACE::DOMDocument* doc);
	void fillDescriptor(XERCES_CPP_NAMESPACE::DOMNodeList *ndList);
#endif
	//! edge histogram vector
	std::vector<char> m_pEdge_Histogram;

	//!match descriptors and return distance
	int match(EdgeHistogram *edHist);
};

#endif;