#include <cv.h>
#include "Descriptor.h"
#include "Regions.h"


class __declspec (dllexport) Extractor
{
public:
	//!extracts descriptors declared in Descriptor object after loading image and mask(null if extraction 
	// !will be done globally)
	bool Extract(const char *imageFilename,const char *maskfilename,Descriptor &descr);
	//!extracts descriptors declared in Descriptor object from image (and mask if included) loaded in 
	//! memory 
	bool Extract(IplImage *image,IplImage *mask,Descriptor &descr);
	//!extracts descriptors declared in DescriptorCollection object from regions of the region map after 
	//! loading image and region map
	bool ExtractFromMap(const char *imageFilename,const char *mapFilename,DescriptorCollection &descrCol);
	//! extracts descriptors declared in DescriptorCollection object from regions of the region map from 
	//! image and region map loaded in memory
	bool ExtractFromMap(IplImage *mainImage,IplImage *regMap,DescriptorCollection &descrCol);
	//! extracts descriptors declared in DescriptorCollection object from bounding boxes in 
	//! textfile (bbListFilename)
	bool ExtractFromBBoxList(const char *imageFilename,const char *bbListFilename,DescriptorCollection &descrCol);
	//! extracts descriptors declared in DescriptorCollection object from bounding boxes in 
	//! a list of bounding boxes
	bool ExtractFromBBoxList(IplImage *mainImage,BoundingBoxList bbList,DescriptorCollection &descrCol);
	
};