#ifndef __HOMOGENEOUSTEXTURE_H__
#define __HOMOGENEOUSTEXTURE_H__

#include "DescriptorBase.h"

class __declspec (dllexport) HomogeneousTexture : public DescriptorBase
{
public:
	HomogeneousTexture();

	friend std::ostream& operator << (std::ostream& os, HomogeneousTexture& s);

	//! initialise the descriptor with the given parameters
	int Initialise(int flag);
	//! set flag for energy deviation presence
	void SetFlag(int flag);
	//! get flag for energy deviation presence
	int GetFlag();
	//! set the size of the descriptor vector
	void SetSize();
	//! get the size of the descriptor vector
	int GetSize();

	void PrintElements();
	std::string toString();

#ifdef USEXML
	XERCES_CPP_NAMESPACE::DOMElement *toXML(XERCES_CPP_NAMESPACE::DOMDocument* doc);
	void fillDescriptor(XERCES_CPP_NAMESPACE::DOMNodeList *ndList);
#endif

	//!match descriptors and return distance
	int match(HomogeneousTexture *homText);
	
	//!descriptor vector
	std::vector<int> feature;
	
};



#endif