#ifndef __REGIONSHAPE_H__
#define __REGIONSHAPE_H__

#include "DescriptorBase.h"


class __declspec (dllexport) RegionShape : public DescriptorBase
{
public:
	//!constructor
	RegionShape();
	
	friend std::ostream& operator << (std::ostream& os, RegionShape& s);

	//!set size of the descriptor vector
	void SetSize();

	void PrintElements();
	std::string toString();
#ifdef USEXML
	XERCES_CPP_NAMESPACE::DOMElement *toXML(XERCES_CPP_NAMESPACE::DOMDocument* doc);
	void fillDescriptor(XERCES_CPP_NAMESPACE::DOMNodeList *ndList);

#endif

	//!match descriptors and return distance
	int match(RegionShape *regShape);

	//!descriptor vector
	std::vector<char>  m_ArtDE;

};



#endif;