#ifndef __REGIONS_H__
#define __REGIONS_H__

#include <list>
#include <cv.h>

//! bounding box structure containing coordinates (x,y) of upper left and lower right corners
typedef struct bndBox
{
	int x1,y1,x2,y2;
} BoundingBox;	

typedef std::list<BoundingBox> BoundingBoxList;
typedef std::list<BoundingBox>::iterator BoundingBoxListIterator;


class __declspec (dllexport) Regions
{
public:
		//!create a list of bounding boxes included in a text file
		BoundingBoxList GetBoundingBoxList(const char *Filename);
		//!calcutate and set the number of regions in the region map image
		int GetNumberOfRegions(IplImage *RegionMap);

};




#endif //__REGIONS_H__