#ifndef __SCALABLECOLOR_H__
#define __SCALABLECOLOR_H__

#include "DescriptorBase.h"

class __declspec (dllexport) ScalableColor : public DescriptorBase
{
public:
	//!constructor
	ScalableColor();
	
	friend std::ostream& operator << (std::ostream& os, ScalableColor& s);

	
	size_t GetByteSize();
	void PrintElements(void);
	std::string toString();
#ifdef USEXML
	XERCES_CPP_NAMESPACE::DOMElement *toXML(XERCES_CPP_NAMESPACE::DOMDocument* doc);
	void fillDescriptor(XERCES_CPP_NAMESPACE::DOMNodeList *ndList);

#endif
	//!match descriptors and return distance
	int match(ScalableColor *scalCol);

	//! initialise the descriptor with the given parameters
	int Initialise(int coef,int bitPlanesDisc);
	//!set size of the descriptor vector
	int SetSize(int Size);
	//! set the number of the bit planes  discarded in the descriptor extraction
	int SetNumberOfBitplanesDiscarded(int discard);
	//!set the number of coefficients
	int SetNumberOfCoefficients(int num_coef);
	//!get size of the descriptor vector
	int GetSize();
	//! get the number of the bit planes  discarded in the descriptor extraction
	int GetNumberOfBitplanesDiscarded();
	//!get the number of coefficients
	int GetNumberOfCoefficients();

	//! descriptor vector
	std::vector<unsigned long> m_ScalableHistogram;  /* An array of m_HistoSize	Coefficients representing the frequency of each quantized value in the  source media */
	//!sign of the descriptor values
	std::vector<unsigned long> m_Sign; // An array of signs of m_HistoSize Coefficients

};


#endif